function [L,T,x] = genExamples3(im, R, X, genData, JJ, model )



N = genData.numOfExamples;                         % Desired number of examples
[r c] = size(im); L = []; T = []; eps = 1e-7; sc = genData.sc;
%convSz = round(1+2*R*sc/M); im = conv2(double(im),ones(convSz)/(convSz^2),'same')/255;
im = double(im);

%% Randomly select a support set
[A B] = meshgrid([-1:1/20:1], [-1:1/20:1]); x = round(sc*[R/2*A(:)'; R/2*B(:)']);     % Considered grid of points
%x = x(:, genRnd(M,size(x,2)));                                               % Generate M random support pixels from the grid
%x = x(:, rInd);                                                               % Generate M random support pixels from the grid
if length(JJ)>0,
x = x(:,JJ);
end;

%% Get template (intensities in support pixels)


I = im(sub2ind(size(im),X(1)+x(1,:),X(2)+x(2,:))); 

%% Generate exaples
[A B] = meshgrid([-1:1/30:1], [-1:1/30:1]); t = [A(:)'; B(:)'];                         % Considered grid of translations
tRnd = t(:, genRnd(N,size(t,2)));                                                 % Generate N random translation from the grid
%zRnd = rand(1,size(t,2)); 
t0 = zeros(5,1);

L = zeros(size(x,2),size(tRnd,2));
T = zeros(5 ,size(tRnd,2)); %length(genData.predTrans),size(tRnd,2));
destr = false(1,size(tRnd,2));
for i=1:size(tRnd,2),         
        zRnd = 1 + 2*genData.zMax*(rand - 0.5);
        t0(1:2) = round([R;R].*(genData.tMax*tRnd(:,i)));
        t0(3) = genData.zMax(1) + (genData.zMax(2)-genData.zMax(1))*rand;
        t0(4) = genData.zMax(1) + (genData.zMax(2)-genData.zMax(1))*rand;
        t0(5) = 2*genData.rMax*(rand - 0.5);
        %x0 = (1+t0(3))*x(1,:); y0 = (1+t0(3))*x(2,:);
        %xx = X(1) + t0(1) + round(x0*cos(t0(4)) - y0*sin(t0(4))); yy = X(2) + t0(2) + round(x0*sin(t0(4)) + y0*cos(t0(4)));
        xp = transformPoints(x,t0,[0;0]); xx = X(1)+xp(1,:); yy = X(2)+xp(2,:); %clf; imshow(im/255); hold on; plot(yy,xx,'.'); 
        
%        xx = X(1) + t0(1) + x(1,:); yy = X(2) + t0(2) + x(2,:);          
        if all((xx>0)&(yy>0)&(xx<r)&(yy<c)),
            J = im(sub2ind(size(im),xx,yy));                           % Get observation           
            if length(model)>0, %exist('model','var'),
            for k=1:length(model),
                t_pred0 = model(k).H*J(1:model(k).C)';%(model(k).I)');
                t_pred = zeros(5,1);
                t_pred(genData.predTrans) = t_pred0;
                t0(1) = t0(1) - round([R].*(t_pred(1)));
                t0(2) = t0(2) - round([R].*(t_pred(2)));
                t0(3) = t0(3) - t_pred(3);%(1+t0(3))/(1+t_pred(3))-1;%t0(3) - t_pred(3);%
                t0(4) = t0(4) - t_pred(4);
                t0(5) = t0(5) - t_pred(5); 
 %               x0 = (1+t0(3))*x(1,:); y0 = (1+t0(3))*x(2,:);
%                xx = X(1) + t0(1) + round(x0*cos(t0(4)) - y0*sin(t0(4))); yy = X(2) + t0(2) + round(x0*sin(t0(4)) + y0*cos(t0(4)));
                xp = transformPoints2(x,t0,[0;0]); xx = X(1)+xp(1,:); yy = X(2)+xp(2,:);
                if all((xx>0)&(yy>0)&(xx<r)&(yy<c)),
                    J = im(sub2ind(size(im),xx,yy));
                else
                    destr(i) = true;
                end;
            end;
            end;
            L(:,i) = J';%[L J'];%-I']; 
           % T = [T [genData.tMax*tRnd(:,i); zRnd-1]];%
           T(:,i) = [t0(1:2)./[R;R]; t0(3:5)];
           %T = [T [t0(1:2)./[R1;R2]; t0(3:4)]];
        end;
end;
L = L(:,~destr);
T = T(:,~destr);

L = L + genData.noise*rand(size(L));

%% Estimate motion predictor
%model.H = T*L'*inv(L*L'+eps*eye(size(L,1)));

%% Return model
%model.I = I';
%model.Err = sqrt(sum((model.H*L-T).^2));
%model.R = R;
%model.x = x;