function model = learnMultiLSQ(L0, T0, C, J, genData, R)
if ~exist('R','var'),
    R = max(abs(T0)');
end;
eps = 1e-7; nextIterErr = 0.95; 
for i=1:length(C),
    I = find(all(T0<=repmat(R',1,size(T0,2)),1)); 
    N = size(L0,2); rnd = genRnd(N, length(I));
    L=L0(:,I(rnd)); T = T0(:,I(rnd)); L = L((1:C(i)),:);
%    model(i).H = weightedLSQ(L,T,1./mean(abs(T),2));%T*L'*inv(L*L'+eps*eye(size(L,1)));
    model(i).H = T*L'*inv(L*L'+eps*eye(size(L,1)));
    model(i).I = J(1:C(i));
    model(i).Err = model(i).H*L-T;
    model(i).R = R;
    model(i).C = C(i);
    Errs = sort(sqrt(sum((model(i).H*L-T).^2))); 
    R = round(Errs(round(length(Errs)*nextIterErr)))+1;
   % disp(sprintf('%3.1f%% (R=%1.3f%%, C=%d)',i/length(C)*100,R(1), C(i)))
end;