%% Initialization
trData.nameModel = 'leguan';                          % name of the object (just for identification).
trData.fName = 'leguan';                              % name of the output model
trData.imgModel = [trData.nameModel,'.jpg'];          % name of the image used for training

trData.tMax = 0.4;                                    % percentage of learned translation 
trData.zMax = [-0.1 0.1];                             % scale
trData.rMax = [pi/12];                                % rotation
trData.noise = 0.1;                                   % additive noise involved in training examples  
trData.predTrans = [1 2];                             % predicted motion transformation (it could theoretically predict also scale and rotation but I wouldn;t try it).

trData.C = [20 300 50 180 90 130 ];%20 300 50 100];          % considered complexities 
trData.iter = length(trData.C);                       % just old stuff
trData.sc = 0.9;                                      % just old stuff
trData.maxCovErr = 0.04;                              % precision on final solution
trData.numOfExamples = 500;                           % number of training examples 
trData.ss = 'rnd';                                    % 'rnd' (random) or 'lsq' (greedy lsq - time consuming)
trData.maxDepth = 6;                                  % maximal depth of the tree

trData.supportRangeRatio = 2;                         % just old stuff
%trData.Range = 25;
trData.minmax = true;                                 % just old stuff
trData.timeLimit = 50;                                % Time limit [seconds]     
trData.ssRadius = 30*trData.supportRangeRatio;

trData.sc = [0.6];                                    % Use also under-sampled image
trData.blurDir = [0 45 90 135];                       % Use also blured image (direction of motion blur in degrees)
trData.blurSize = [3];                                % Size of motion blur.
trData.visu = false;                                  % Visualization
trData.sav = false;                                   % Save visualization images during learning procedure

im = double(rgb2gray(imread(trData.imgModel)))/255; 
model = tcLearn(im, trData);
save(trData.fName,'model');



